// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been
// thoroughly tested under all conditions. Add-in Express, therefore, cannot
// guarantee its reliability, serviceability or functionality.

unit SwitchingWebViewPaneD7_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Outlook2000, Office2000, adxAddIn, SwitchingWebViewPaneD7_TLB, StdVcl,
  Classes, adxolFormsManager;

type
  TCoSwitchingWebViewPaneD7 = class(TadxAddin, ICoSwitchingWebViewPaneD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxOlFormsManager1: TadxOlFormsManager;
    procedure adxOlFormsManager1Initialize(ASender: TObject);
    procedure adxOlFormsManager1ADXBeforeFolderSwitchEx(ASender: TObject;
      ExplorerObj: _Explorer; SrcFolder, DstFolder: MAPIFolder);
  private
    function GetWebViewPaneADXOlFormsCollectionItem: TadxOlFormsCollectionItem;
  protected
  public
    procedure DoShowWebViewPane;
    procedure DoHideWebViewPane;
    property WebViewPaneADXOlFormsCollectionItem: TadxOlFormsCollectionItem read GetWebViewPaneADXOlFormsCollectionItem;
  end;

implementation

uses uNavigationPaneForm, Unit2, uUtils;

{$R *.dfm}

{ TAddInModule }

procedure TAddInModule.DoHideWebViewPane;
var
  currentFolder: MAPIFolder;
  activeExplorer: Explorer;
begin
  if (ADXUtils.ExistsVisibleForm(WebViewPaneADXOlFormsCollectionItem)) then begin
      activeExplorer := OutlookApp.ActiveExplorer;
      currentFolder := activeExplorer.CurrentFolder;
      try
          WebViewPaneADXOlFormsCollectionItem.FolderName := '';
          OutlookUtils.ClearFolderWebViewProperties(currentFolder);
          //Restore Standard View
          OutlookUtils.RefreshCurrentFolder(OutlookApp.ActiveExplorer);
      finally
        currentFolder := nil;
      end;
  end;
end;

procedure TAddInModule.DoShowWebViewPane;
var
  currentFullFolderName: string;
begin
  currentFullFolderName := OutlookUtils.GetFullNameOfCurrentFolder(self.OutlookApp.DefaultInterface);
  webViewPaneADXOlFormsCollectionItem.FolderName := currentFullFolderName;
  //Apply the WebViewPane layout
  OutlookUtils.RefreshCurrentFolder(OutlookApp.ActiveExplorer);
end;

procedure TAddInModule.adxOlFormsManager1Initialize(ASender: TObject);
begin
  OutlookUtils.InitOutlookVersion(self.OutlookApp.DefaultInterface);
end;

procedure TAddInModule.adxOlFormsManager1ADXBeforeFolderSwitchEx(
  ASender: TObject; ExplorerObj: _Explorer; SrcFolder,
  DstFolder: MAPIFolder);
var
  folderName: string;
begin
  if (not OutlookUtils.RefreshCurrentFolderExecuting) then begin
    if (SrcFolder <> nil) then begin
        folderName := OutlookUtils.GetFullFolderName(SrcFolder);
        if (ADXUtils.IsADXWebViewUrl(SrcFolder)
            and (Common.IndexOfString(folderName, WebViewPaneADXOlFormsCollectionItem.FolderName) = 1)) then begin
            WebViewPaneADXOlFormsCollectionItem.FolderName := '';
            OutlookUtils.ClearFolderWebViewProperties(SrcFolder);
        end;
    end;
  end;
end;


function TAddInModule.GetWebViewPaneADXOlFormsCollectionItem: TadxOlFormsCollectionItem;
begin
  result := adxOlFormsManager1.Items[1];
end;

initialization
  TadxFactory.Create(ComServer, TCoSwitchingWebViewPaneD7, CLASS_CoSwitchingWebViewPaneD7, TAddInModule);

end.
